frontend/main/routes/bolsones.py
from flask import Blueprint, redirect, url_for, render_template, current_app, request, flash
from .. formularios.bolson import FormBolson, FormFilterBolson, FormFilterBolsones
from flask_login import login_required, LoginManager, current_user
import requests, json
from .auth import admin_required, proveerdor_required, cliente_required, admin_provider_required, admin_client_required


bolsones = Blueprint('bolsones', __name__, url_prefix='/bolson')


@bolsones.route('/<int:id>')
@login_required
@admin_required
def ver(id):
    user = current_user
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config["API_URL"]+'/bolson/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        return redirect(url_for('bolsones.ver_todos'))
    bolson = json.loads(r.text)
    return render_template('bolson.html', bolson = bolson, user = user)

@bolsones.route('/todos')
@login_required
@admin_required
def ver_todos():
    user = current_user
    filter = FormFilterBolsones(request.args, meta={'csrf': False})
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')
    
    if filter.envio():
        if filter.desde.data != None:
            data['desde'] = filter.desde.data.strftime('%Y-%m-%d')
        if filter.hasta.data != None:
            data['hasta'] = filter.hasta.data.strftime('%Y-%m-%d')

    print(data)

    r = requests.get(
        current_app.config["API_URL"]+'/bolsones',
        headers = headers,
        data = json.dumps(data))
    bolsones = json.loads(r.text)["bolsones"] 
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"] 
    return render_template('bolsones_admin.html', bolsones = bolsones, pagination = pagination, filter = filter, user = user)

@bolsones.route('/ver/<int:id>')
def ver_en_venta(id):
    user = current_user
    r = requests.get(
            current_app.config["API_URL"]+'/bolson-venta/'+str(id),
            headers = {"content-type": "application/json"})
    if (r.status_code == 404):
        return redirect(url_for('bolsones.ver_todos_en_venta'))
    bolson = json.loads(r.text)
    return render_template('bolson.html', bolson = bolson, user = user)

@bolsones.route('/ver-todos')
def ver_todos_en_venta():
    filter = FormFilterBolson(request.args, meta={'csrf': False})
    data = {}
    data['page'] = 1
    data['per_page'] = 2
    if 'page' in request.args:
        data['page'] = request.args.get('page','')
    headers = {'content-type':'application/json'}
    
    if filter.envio():
        if filter.nombre.data != None:
            data["nombre"] = filter.nombre.data
        if filter.desde.data != None:
            data["desde"] = filter.desde.data
        if filter.hasta.data != None:
            data["hasta"] = filter.hasta.data
        if filter.ordenamiento.data != None:
            data["ordenamiento"] = filter.ordenamiento.data

    r = requests.get(
        current_app.config["API_URL"]+'/bolsones-venta',
        headers = headers,
        data = json.dumps(data))
    bolsones = json.loads(r.text)["bolsonesventas"]
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('bolsones.html', bolsones = bolsones, pagination = pagination, filter = filter)

@bolsones.route('/pendiente/<int:id>', methods=['POST', 'GET'])
@login_required
@admin_provider_required
def ver_pendiente(id):
    user = current_user
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config["API_URL"]+'/bolson-pendiente/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        return redirect(url_for('main.index'))
    bolson = json.loads(r.text)
    return render_template('bolson.html', bolson = bolson, user = user)

@bolsones.route('/pendientes')
@login_required
@admin_provider_required
def ver_pendientes():
    user = current_user
    filter = FormFilterBolsones(request.args, meta={'csrf': False})
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}

    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')

    if filter.envio():
        if filter.desde.data != None:
            data['desde'] = filter.desde.data.strftime('%Y-%m-%d')
        if filter.hasta.data != None:
            data['hasta'] = filter.hasta.data.strftime('%Y-%m-%d')

    r = requests.get(
            current_app.config["API_URL"]+'/bolsones-pendientes',
            headers = headers,
            data = json.dumps(data))
    bolsones = json.loads(r.text)["bolsones pendientes"]
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('bolsones_pendientes.html', bolsones = bolsones, pagination = pagination, filter = filter, user = user)

@bolsones.route('/previo/<int:id>')
@login_required
@admin_required
def ver_previo(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config["API_URL"]+'/bolson-previo/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        return redirect(url_for('bolsones.ver_todos'))
    bolson = json.loads(r.text)
    return render_template('bolson.html', bolson = bolson)

@bolsones.route('/previos')
@login_required
@admin_required
def ver_previos():
    user = current_user
    filter = FormFilterBolsones(request.args, meta={'csrf': False})
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')

    if filter.envio():
        if filter.desde.data != None:
            data['desde'] = filter.desde.data.strftime('%Y-%m-%d')
        if filter.hasta.data != None:
            data['hasta'] = filter.hasta.data.strftime('%Y-%m-%d')

    r = requests.get(
        current_app.config["API_URL"]+'/bolsones-previos',
        headers = headers,
        data = json.dumps(data))
    bolsones = json.loads(r.text)["bolsones previos"] 
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('bolsones_previos.html', bolsones = bolsones, pagination = pagination, filter = filter, user = user)

@bolsones.route('/crear', methods=['POST', 'GET'])
@login_required
@admin_required
def crear():
    form = FormBolson()
    data = {}
    data['page'] = 1
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config["API_URL"]+'/productos',
            headers = headers,
            data = json.dumps(data))
    productos = [(item['id'], item['nombre']+"\n - "+item['proveedor']) for item in json.loads(r.text)["productos"]]

    form.productosId.choices = productos
    if form.validate_on_submit():
        auth = request.cookies['access_token']
        headers = {
                'content-type': 'application/json',
                'authorization': 'Bearer '+auth}
        data = {}
        data["nombre"] = form.nombre.data
        data["fecha"] = form.fecha.data.strftime("%Y-%m-%d")
        data["precio"] = form.precio.data
        data["productos"] = form.productosId.data
        print(data)
        r = requests.post(
                current_app.config["API_URL"]+'/bolsones-pendientes',
                headers = headers,
                data = json.dumps(data))
        if (r.status_code == 201):
            flash('Bolsón creado.', 'success')
            return redirect(url_for('bolsones.ver_pendientes'))
    return render_template('crear_bolson.html', form = form)

@bolsones.route('eliminar/<int:id>')
@login_required
@admin_required
def eliminar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-Type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.delete(
            current_app.config["API_URL"]+'/bolson-pendiente/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        flash('Bolsón no encontrado.', 'danger')
        return redirect(url_for('bolsones.ver_pendientes'))
    flash('Bolsón eliminado', 'success')
    return redirect(url_for('bolsones.ver_pendientes'))

@bolsones.route('aprobar/<int:id>')
@login_required
@admin_required
def aprobar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    data = {}
    data["aprobado"] = 1
    r = requests.put(
            current_app.config['API_URL']+'/bolson-pendiente/'+str(id),
            headers=headers,
            data = json.dumps(data))
    if (r.status_code == 201):
        flash('Bolsón aprobar', 'success')
        return redirect(url_for('bolsones.ver_todos'))
    return redirect(url_for('bolsones.ver_todos'))

@bolsones.route('desaprobar/<int:id>')
@login_required
@admin_required
def desaprobar(id):

frontend/main/routes/main.py
from flask import Blueprint, url_for, render_template, current_app, redirect, request, make_response, flash
from .. formularios.ingresar import FormIngreso
from flask_login import login_required, login_user, logout_user, current_user, LoginManager
from . import usuario
import requests, json
from .auth import User


main = Blueprint('main', __name__, url_prefix='/')


@main.route('/')
def index():
    data = {}
    data['page'] = 1
    r = requests.get(
            current_app.config['API_URL']+'/bolsones-venta',
            headers ={"content-type": "application/json"},
            data = json.dumps(data))
    bolsones = json.loads(r.text)["bolsonesventas"]
    return render_template('index.html', bolsones = bolsones)

@main.route('/ingresar', methods=['POST'])
def login():
    form = FormIngreso()
    if form.validate_on_submit():
        data = '{"email":"'+form.email.data+'", "password":"'+form.password.data+'"}'
        r = requests.post(
                current_app.config["API_URL"]+'/auth/login',
                headers={"content-type": "application/json"},
                data = data)
        if r.status_code == 200:
            user_data = json.loads(r.text)
            user = User(id = user_data.get("id"), email = user_data.get("email"), role = user_data.get("role"))
            login_user(user)
            req = make_response(redirect(url_for('main.index')))
            req.set_cookie('access_token', user_data.get("access_token"), httponly = True)
            return req
        else:
            flash('Usuario o contraseña incorrecta', 'danger')
            return redirect(url_for('usuarios.ingresar'))
    return redirect(url_for('main.index'))

@main.route('/cerrar-sesion')
def logout():
    req = make_response(redirect(url_for('main.index')))
    req.set_cookie('access_token', '', httponly = True)
    logout_user()
    return req

@main.route('/nosotros')
def nosotros():
    return render_template('nosotros.html')

@main.route('/zona-de-retiro')
def retiro():
    return render_template('zona_retiro.html')

@main.route('/ayuda')
def ayuda():
    return render_template('preguntas.html')

frontend/main/routes/proveedor.py
from flask import Blueprint, render_template, redirect, url_for, current_app, request, flash
from .. formularios.registrarse import FormRegistro
from .. formularios.proveedores import FormFilterProveedor
from flask_login import login_required, LoginManager, current_user
import requests, json
from .auth import admin_required, proveerdor_required


proveedores = Blueprint('proveedores', __name__, url_prefix='/proveedores')


@proveedores.route('/registrar', methods=['POST', 'GET'])
@login_required
@admin_required
def registrar():
    form = FormRegistro()
    if form.validate_on_submit():
        data = {}
        data["nombre"] = form.nombre.data
        data["apellido"] = form.apellido.data
        data["email"] = form.email.data
        data["telefono"] = form.telefono.data
        data["password"] = form.password.data
        data["role"] = 'proveedor'
        headers = {"content-type": "application/json"}
        print(data)
        r = requests.post(
                current_app.config["API_URL"]+'/auth/register',
                headers = headers,
                data = json.dumps(data))
        flash('Proveedor creado.', 'success')
        return redirect(url_for('proveedores.ver_todos'))
    return render_template('crear_proveedor.html', formulario=form)

@proveedores.route('/ver/<int:id>')
def ver(id):
    user = current_user
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config["API_URL"]+'/proveedor/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        return redirect(url_for('proveedores.ver_todos'))
    proveedor = json.loads(r.text)
    return render_template('cliente.html', usuario = proveedor, user = user)


@proveedores.route('/todos')
@login_required
@admin_required
def ver_todos():
    filter = FormFilterProveedor(request.args, meta={'csrf': False})
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    if filter.envio():
        if filter.ordenamiento.data != None:
            data["ordenamiento"] =  filter.ordenamiento.data

    r = requests.get(
            current_app.config["API_URL"]+'/proveedores',
            headers = headers,
            data = json.dumps(data))
    proveedores = json.loads(r.text)["proveedores"]
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('proveedores_admin.html', proveedores = proveedores, pagination = pagination, filter = filter)

@proveedores.route('/eliminar/<int:id>')
@login_required
@admin_required
def eliminar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    r = requests.delete(
            current_app.config['API_URL']+'/proveedor/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        flash('Proveedor no encontrado.', 'danger')
        return redirect(url_for('proveedores.ver_todos'))
    flash('Proveedor eliminado.', 'success')
    return redirect(url_for('proveedores.ver_todos'))

frontend/main/templates/bolsones_admin.html
{% extends "main.html" %}
{% import 'macros/bolson.html' as macro %}
{% from 'macros/form_macros.html' import MostrarCampo, MostrarEnvio %}
{% block content %}
<div class="row">
  <div class="col-md-1 col-sm-1"></div>
  <div class="col-md-10 col-sm-1 border border-1 p-1">
    <h3>Bolsones</h3>
    <div>
      <a class="btn btn-primary" type="button" href="{{url_for('bolsones.ver_todos')}}">Todos</a>
      <a class="btn btn-primary" type="button" href="{{url_for('bolsones.ver_pendientes')}}">Pendientes</a>
      <a class="btn btn-primary" type="button" href="{{url_for('bolsones.ver_previos')}}">Previos</a>
    </div>
    </br>
    <div class="row">
      <div class="col-md-1"></div>
      <div class="col-md-8 col-sm-6 d">
        <form method="GET" action="{{url_for('bolsones.ver_todos')}}">
          <div class="form-group d-flex col-md-8">
            {{ MostrarCampo(filter.desde, class="form-control", placeholder="Desde") }}
            {{ MostrarCampo(filter.hasta, class="form-control", placeholder="Hasta") }}
            {{ MostrarEnvio(filter.envio, class="btn btn-success") }}
          </div>
        </form>
      </div>
      <div class="col-md-2 col-sm-6">
        <nav aria-label="Pagination">
          <ul class="pagination justify-content-center">
            {% if pagination.current_page != 1 %}
            <li class="page-item">
              <a class="page-link" href="{{url_for('bolsones.ver_todos', page = (pagination.current_page-1),
                desde = request.args.desde,
                hasta = request.args.hasta)}}">
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            {% endif %}
            {% for n in range(1, pagination.pages+1) %}
            {% if n != pagination.current_page %}
            <li class="page-item" aria-current="page">
              <a class="page-link" href="{{url_for('bolsones.ver_todos', page = n,
                desde = request.args.desde,
                hasta = request.args.hasta)}}">{{n}}</a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">{{n}}</a>
            </li>
            {% endif %}
            {% endfor %}
            {% if pagination.current_page != pagination.pages %}
            <li class="page-item">
              <a class="page-link" href="{{url_for('bolsones.ver_todos', page = (pagination.current_page+1),
                desde = request.args.desde,
                hasta = request.args.hasta)}}">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
            {% endif %}
          </ul>
        </nav>
      </div>
      <div class="col-md-1 col-sm-1"></div>
    </div>
    <div class="row">
      <div class="col-md-1 col-sm-1"></div>
      <div class="col-md-10 col-sm-1 border border-1">
        <table class="table align-middle">
          <thead>
            <tr>
              <th scope="col">Bolsón</th>
              <!-- <th scope="col"></th> -->
              <th scope="col">Fecha</th>
              <th scope="col">Aprobado</th>
              <th scope="col">Precio</th>
              <th scope="col"></th>
            </tr>
          </thead>
          <tbody>
            {% for bolson in bolsones %}
            {{ macro.bolsones(bolson, user) }}
            {% endfor %}
          </tbody>
        </table>
      </div>
      <div class="col-md-1 col-sm-1"></div>
    </div>
    <br/>
    <nav aria-label="Pagination">
      <ul class="pagination justify-content-center">
        {% if pagination.current_page != 1 %}
        <li class="page-item">
          <a class="page-link" href="{{url_for('bolsones.ver_todos', page = (pagination.current_page-1),
            desde = request.args.desde,
            hasta = request.args.hasta)}}">
            <span aria-hidden="true">&laquo;</span>
          </a>
        </li>
        {% else %}
        <li class="page-item disabled">
          <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
            <span aria-hidden="true">&laquo;</span>
          </a>
        </li>
        {% endif %}
        {% for n in range(1, pagination.pages+1) %}
        {% if n != pagination.current_page %}
        <li class="page-item" aria-current="page">
          <a class="page-link" href="{{url_for('bolsones.ver_todos', page = n,
            desde = request.args.desde,
            hasta = request.args.hasta)}}">{{n}}</a>
        </li>
        {% else %}
        <li class="page-item disabled">
          <a class="page-link" href="#" tabindex="-1" aria-disabled="true">{{n}}</a>
        </li>
        {% endif %}
        {% endfor %}
        {% if pagination.current_page != pagination.pages %}
        <li class="page-item">
          <a class="page-link" href="{{url_for('bolsones.ver_todos', page = (pagination.current_page+1),
            desde = request.args.desde,
            hasta = request.args.hasta)}}">
            <span aria-hidden="true">&raquo;</span>
          </a>
        </li>
        {% else %}
        <li class="page-item disabled">
          <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
            <span aria-hidden="true">&raquo;</span>
          </a>
        </li>
        {% endif %}
      </ul>
    </nav>
  </div>
  <br/>
</div>
{% endblock %}

frontend/main/templates/bolsones_pendientes.html
{% extends "main.html" %}
{% import 'macros/bolson.html' as macro %}
{% from 'macros/form_macros.html' import MostrarCampo, MostrarEnvio %}
{% block content %}
<div class="row">
  <div class="col-md-1 col-sm-1"></div>
  <div class="col-md-10 col-sm-1 border border-1 p-1">
    <h3>Bolsones Pendientes</h3>
    {% if current_user.role == 'admin' %}
    <div>
      <a class="btn btn-primary" type="button" href="{{url_for('bolsones.ver_todos')}}">Todos</a>
      <a class="btn btn-primary" type="button" href="{{url_for('bolsones.ver_pendientes')}}">Pendientes</a>
      <a class="btn btn-primary" type="button" href="{{url_for('bolsones.ver_previos')}}">Previos</a>
    </div>
    </br>
    {% endif %}
    <div class="row">
      {% if current_user.role == 'admin' %}
      <div class="col-md-2 col-sm-6">
        <a href="{{url_for('bolsones.crear')}}" type="button" class="btn btn-success ">Crear bolsón</a>
      </div>
      <div class="col-md-8 col-sm-6">
      {% else %}
      <div class="col-md-10 col-sm-6">
      {% endif %}
        <form method="GET" action="{{url_for('bolsones.ver_pendientes')}}">
          <div class="form-group d-flex col-md-5">
            {{ MostrarCampo(filter.desde, class="form-control", placeholder="Desde") }}
            {{ MostrarCampo(filter.hasta, class="form-control", placeholder="Hasta") }}
            {{ MostrarEnvio(filter.envio, class="btn btn-success") }}
          </div>
        </form>
      </div>
      <div class="col-md-2 col-sm-6">
        <nav aria-label="Pagination">
          <ul class="pagination justify-content-center">
            {% if pagination.current_page != 1 %}
            <li class="page-item">
              <a class="page-link" href="{{url_for('bolsones.ver_pendientes', page = (pagination.current_page-1),
                desde = request.args.desde,
                hasta = request.args.hasta)}}">
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            {% endif %}
            {% for n in range(1, pagination.pages+1) %}
            {% if n != pagination.current_page %}
            <li class="page-item" aria-current="page">
              <a class="page-link" href="{{url_for('bolsones.ver_pendientes', page = n,
                desde = request.args.desde,
                hasta = request.args.hasta)}}">{{n}}</a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">{{n}}</a>
            </li>
            {% endif %}
            {% endfor %}
            {% if pagination.current_page != pagination.pages %}
            <li class="page-item">
              <a class="page-link" href="{{url_for('bolsones.ver_pendientes', page = (pagination.current_page+1),
                desde = request.args.desde,
                hasta = request.args.hasta)}}">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
            {% endif %}
          </ul>
        </nav>
      </div>
    </div>
    <div class="row">
      <div class="col-md-1 col-sm-1"></div>
      <div class="col-md-10 col-sm-1 border border-1">
        <table class="table align-middle">
          <thead>
            <tr>
              <th scope="col">Bolsón</th>
              <th scope="col">Fecha</th>
              <th scope="col">Aprobado</th>
              <th scope="col">Precio</th>
              <th scope="col"></th>
              <th scope="col"></th>
            </tr>
          </thead>
          <tbody>
            {% for bolson in bolsones %}
            {{ macro.pendientes(bolson) }}
            {% endfor %}
          </tbody>
        </table>
      </div>
      <div class="col-md-1 col-sm-1"></div>
    </div>
    <br/>
        <nav aria-label="Pagination">
          <ul class="pagination justify-content-center">
            {% if pagination.current_page != 1 %}
            <li class="page-item">
              <a class="page-link" href="{{url_for('bolsones.ver_pendientes', page = (pagination.current_page-1),
                desde = request.args.desde,
                hasta = request.args.hasta)}}">
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            {% endif %}
            {% for n in range(1, pagination.pages+1) %}
            {% if n != pagination.current_page %}
            <li class="page-item" aria-current="page">
              <a class="page-link" href="{{url_for('bolsones.ver_pendientes', page = n,
                desde = request.args.desde,
                hasta = request.args.hasta)}}">{{n}}</a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">{{n}}</a>
            </li>
            {% endif %}
            {% endfor %}
            {% if pagination.current_page != pagination.pages %}
            <li class="page-item">
              <a class="page-link" href="{{url_for('bolsones.ver_pendientes', page = (pagination.current_page+1),
                desde = request.args.desde,
                hasta = request.args.hasta)}}">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
            {% else %}
            <li class="page-item disabled">
              <a class="page-link" href="#" tabindex="-1" aria-disabled="true">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
            {% endif %}
          </ul>
        </nav>
  </div>
  {% endblock %}

frontend/main/templates/crear_bolson.html
{% extends "main.html" %}
{% from 'macros/form_macros.html' import MostrarCampo, MostrarEnvio %}
{% block content %}
<div class="row">
  <div class="col-md-1 col-sm-1"></div>
  <div class="col-md-10 col-sm-1 border border-1">
    <h3>Crear Bolsón</h3>
    <form method="POST" action="{{url_for('bolsones.crear')}}">
      <input type="hidden" name="csrf_token" value="{{csrf_token()}}">
      <div class="d-flex justify-content-center p-2 bd-highlight border border-1">
        <!-- <div class="d-flex p-2">
          <div class="input-group mb-3">
            <label class="input-group-text" for="inputGroupFile01">
              <img src="https://via.placeholder.com/100x100">
            </label>
            <input type="file" class="form-control" style="display:none" id="inputGroupFile01" accept="image/*">
          </div>
        </div> -->
        <div class="p-2">
          <div class="mb-3">
            {{MostrarCampo(form.nombre, class="form-control")}}
          </div>
          <div class="mb-3">
            {{MostrarCampo(form.fecha, class="form-control")}}
          </div>
          <div class="mb-3">
            {{MostrarCampo(form.precio, class="form-control")}}
          </div>
        </div>
        <div class="p-2">
          <div class="d-flex justify-content-center">
            <div class="p-2">
              <h6>Productos: </h6>
            </div>
            <div>
              {{MostrarCampo(form.productosId, class="form-control", style="text-align:justify")}}
            </div>
          </div>
        </div> 
      </div>
      <div class="d-flex justify-content-center m-2">
        {{MostrarEnvio(form.envio, class="btn btn-primary m-2")}}
        <button class="btn btn-primary m-2" type="button" onclick="history.back()">Volver</button>
      </div>
    </form>
  </div>
  <div class="col-md-1 col-sm-1"></div>
</div>
{% endblock %}